summaryrefslogtreecommitdiffstats
path: root/scripts
diff options
context:
space:
mode:
authorGiuseppe Di Natale <[email protected]>2017-03-31 09:33:38 -0700
committerBrian Behlendorf <[email protected]>2017-03-31 09:33:38 -0700
commitcb524aa23aa6f5bc4242e3b585a58bdd3292ae0f (patch)
treee23dbe898362eac3151bb67990e97974070874d5 /scripts
parent10cb2e0a19e46ecfe1378ccf79e71d986936f17e (diff)
Commit message format in contributing guidelines
Add the need to have a commit message with a specific format to the contributing guidelines. Provide a script to help enforce commit message style. Reviewed-by: Brian Behlendorf <[email protected]> Reviewed-by: George Melikov <[email protected]> Signed-off-by: Giuseppe Di Natale <[email protected]> Closes #5943
Diffstat (limited to 'scripts')
-rwxr-xr-xscripts/commitcheck.sh144
1 files changed, 144 insertions, 0 deletions
diff --git a/scripts/commitcheck.sh b/scripts/commitcheck.sh
new file mode 100755
index 000000000..723109112
--- /dev/null
+++ b/scripts/commitcheck.sh
@@ -0,0 +1,144 @@
+#!/bin/bash
+
+REF="HEAD"
+
+# test a url
+function test_url()
+{
+ url="$1"
+ if ! curl --output /dev/null --max-time 60 \
+ --silent --head --fail "$url" ; then
+ echo "\"$url\" is unreachable"
+ return 1
+ fi
+}
+
+# check for a tagged line
+function check_tagged_line()
+{
+ regex='^\s*'"$1"':\s+\S+\s+\<\S+\>'
+ foundline=$(git log -n 1 "$REF" | egrep -m 1 "$regex")
+ if [ -z "$foundline" ]; then
+ echo "error: missing \"$1\""
+ return 1
+ fi
+
+ return 0
+}
+
+# check for a tagged line and check that the link is valid
+function check_tagged_line_with_url ()
+{
+ regex='^\s*'"$1"':\s+\K(\S+)'
+ foundline=$(git log -n 1 "$REF" | grep -Po "$regex")
+ if [ -z "$foundline" ]; then
+ echo "error: missing \"$1\""
+ return 1
+ fi
+
+ if ! test_url "$foundline"; then
+ return 1
+ fi
+
+ return 0
+}
+
+# check commit message for a normal commit
+function new_change_commit()
+{
+ error=0
+
+ # subject is not longer than 50 characters
+ long_subject=$(git log -n 1 --pretty=%s "$REF" | egrep -m 1 '.{51}')
+ if [ -n "$long_subject" ]; then
+ echo "error: commit subject over 50 characters"
+ error=1
+ fi
+
+ # need a signed off by
+ if ! check_tagged_line "Signed-off-by" ; then
+ error=1
+ fi
+
+ # ensure that no lines in the body of the commit are over 72 characters
+ body=$(git log -n 1 --pretty=%b "$REF" | egrep -m 1 '.{73}')
+ if [ -n "$body" ]; then
+ echo "error: commit message body contains line over 72 characters"
+ error=1
+ fi
+
+ return $error
+}
+
+function is_openzfs_port()
+{
+ # subject starts with OpenZFS means it's an openzfs port
+ subject=$(git log -n 1 --pretty=%s "$REF" | egrep -m 1 '^OpenZFS')
+ if [ -n "$subject" ]; then
+ return 0
+ fi
+
+ return 1
+}
+
+function openzfs_port_commit()
+{
+ # subject starts with OpenZFS dddd
+ subject=$(git log -n 1 --pretty=%s "$REF" | egrep -m 1 '^OpenZFS [[:digit:]]+ - ')
+ if [ -z "$subject" ]; then
+ echo "OpenZFS patch ports must have a summary that starts with \"OpenZFS dddd - \""
+ error=1
+ fi
+
+ # need an authored by line
+ if ! check_tagged_line "Authored by" ; then
+ error=1
+ fi
+
+ # need a reviewed by line
+ if ! check_tagged_line "Reviewed by" ; then
+ error=1
+ fi
+
+ # need a approved by line
+ if ! check_tagged_line "Approved by" ; then
+ error=1
+ fi
+
+ # need ported by line
+ if ! check_tagged_line "Ported-by" ; then
+ error=1
+ fi
+
+ # need a url to openzfs commit and it should be valid
+ if ! check_tagged_line_with_url "OpenZFS-commit" ; then
+ error=1
+ fi
+
+ # need a url to illumos issue and it should be valid
+ if ! check_tagged_line_with_url "OpenZFS-issue" ; then
+ error=1
+ fi
+
+ return $error
+}
+
+if [ -n "$1" ]; then
+ REF="$1"
+fi
+
+# if openzfs port, test against that
+if is_openzfs_port; then
+ if ! openzfs_port_commit ; then
+ exit 1
+ else
+ exit 0
+ fi
+fi
+
+# have a normal commit
+if ! new_change_commit ; then
+ exit 1
+fi
+
+exit 0